% Adaptive Control of Lorenz System : with additive state noise

clear all;
close all;
clc,

Sigma = 10;          %actual system parameters (unknown to the controller)
Beta = 8/3;
Rho = 28;

x10 = -2;            %system's initial condition
x20 = -1;
x30 = 30;

Beta0 = 4;           %initial estimation of parameters
Rho0 = 33;

sim_time = 100;

sim lorenzs1,         %simulate the model

plot3(x1.signals.values,x3.signals.values,x2.signals.values)      %plotting
title('Adaptive control of Lorenz system')
xlabel('x1')
ylabel('x3')
zlabel('x2')
grid on,

figure
subplot(311)
plot(x1.time,x1.signals.values)
title('System states')
ylabel('x1')

subplot(312)
plot(x1.time,x2.signals.values)
ylabel('x2')

subplot(313)
plot(x1.time,x3.signals.values)
xlabel('time')
ylabel('x3')

figure
subplot(211)
plot(x1.time,Beta_Est.signals.values)
title('system parameters (actual parameters is shown red)')
ylabel('Beta')
hold on
plot(x1.time,Beta*ones(size(Beta_Est.signals.values,1),1),'r')
hold off,

subplot(212)
plot(x1.time,Rho_Est.signals.values)
xlabel('time')
ylabel('Rho')
hold on
plot(x1.time,Rho*ones(size(Rho_Est.signals.values,1),1),'r')
hold off,